﻿-- Addon: QuestTranslator (wersja: 70000.01) 2016.07.20
-- Opis: AddOn wyświetla przetłumaczone questy podczas rozmowy z NPC.
-- Autor: Platine  (e-mail: platine.wow@gmail.com)
-- Addon project: http://qtr.top.098.pl

-- Zmienne globalne
      QTR_version = GetAddOnMetadata("QuestTranslator", "Version");
local QTR_name = UnitName("player");
local QTR_class= UnitClass("player");
local QTR_race = UnitRace("player");
local QTR_waitTable = {};
local QTR_waitFrame = nil;
local QuestTranslator_MessOrig = {
      details    = "Description", 
      objectives = "Objectives", 
      rewards    = "Rewards", 
      itemchoose1= "You will be able to choose one of these rewards:", 
      itemchoose2= "Choose one of these rewards:", 
      itemreceiv1= "You will also receive:", 
      itemreceiv2= "You receiving the reward:", 
      learnspell = "Learn Spell:", 
      reqmoney   = "Required Money:", 
      reqitems   = "Required items:", 
      experience = "Experience:", 
      currquests = "Current Quests", 
      avaiquests = "Available Quests", };
local QTR_quest_EN = {
      id = 0,
      title = "",
      details = "",
      objectives = "",
      progress = "",
      completion = "",
      itemchoose = "",
      itemreceive = "", };      
local QTR_quest_LG = {
      id = 0,
      title = "",
      details = "",
      objectives = "",
      progress = "",
      completion = "",
      itemchoose = "",
      itemreceive = "", };      
local QTR_Reklama = {
      ON = "Reklamuj dodatek na czacie kanału 1:GENERAL",
      PERIOD= "Okres czasu pomiędzy kolejnymi reklamami:";
      CHOICE= "Który tekst wyświetlać? (gdy zaznaczysz oba, to naprzemian):";
      TEXT1 = "QuestTranslator - addon that displays the translated quests (qtr.top.098.pl)",
      TEXT2 = "QuestTranslator - dodatek wyświetlający przetłumaczone questy (qtr.top.098.pl)", };
local last_time = GetTime();
local last_text = 0;
local curr_trans = "1";
local Original_Font1 = "Fonts\\MORPHEUS.ttf";
local Original_Font2 = "Fonts\\FRIZQT__.ttf";



-- Pierwsza funkcja wywoływana po załadowaniu dodatku
function QTR_OnLoad()
   QTR = CreateFrame("Frame");
   QTR:SetScript("OnEvent", QTR_OnEvent);
   QTR:RegisterEvent("ADDON_LOADED");
   QTR:RegisterEvent("QUEST_DETAIL");
   QTR:RegisterEvent("QUEST_PROGRESS");
   QTR:RegisterEvent("QUEST_COMPLETE");

   -- przycisk z nr ID questu w QuestFrame
   QTR_ToggleButton0 = CreateFrame("Button",nil, QuestFrame, "UIPanelButtonTemplate");
   QTR_ToggleButton0:SetWidth(150);
   QTR_ToggleButton0:SetHeight(20);
   QTR_ToggleButton0:SetText("Quest ID=?");
   QTR_ToggleButton0:Show();
   QTR_ToggleButton0:ClearAllPoints();
   QTR_ToggleButton0:SetPoint("TOPLEFT", QuestFrame, "TOPLEFT", 92, -25);
   QTR_ToggleButton0:SetScript("OnClick", QTR_ON_OFF);
   
   -- przycisk z nr ID questu w QuestLogPoputDetailFrame
   QTR_ToggleButton1 = CreateFrame("Button",nil, QuestLogPopupDetailFrame, "UIPanelButtonTemplate");
   QTR_ToggleButton1:SetWidth(150);
   QTR_ToggleButton1:SetHeight(20);
   QTR_ToggleButton1:SetText("Quest ID=?");
   QTR_ToggleButton1:Show();
   QTR_ToggleButton1:ClearAllPoints();
   QTR_ToggleButton1:SetPoint("TOPLEFT", QuestLogPopupDetailFrame, "TOPLEFT", 40, -31);
   QTR_ToggleButton1:SetScript("OnClick", QTR_ON_OFF);

   -- przycisk z nr ID questu w QuestMapDetailsScrollFrame
   QTR_ToggleButton2 = CreateFrame("Button",nil, QuestMapDetailsScrollFrame, "UIPanelButtonTemplate");
   QTR_ToggleButton2:SetWidth(150);
   QTR_ToggleButton2:SetHeight(20);
   QTR_ToggleButton2:SetText("Quest ID=?");
   QTR_ToggleButton2:Show();
   QTR_ToggleButton2:ClearAllPoints();
   QTR_ToggleButton2:SetPoint("TOPLEFT", QuestMapDetailsScrollFrame, "TOPLEFT", 116, 29);
   QTR_ToggleButton2:SetScript("OnClick", QTR_ON_OFF);

   -- funkcja wywoływana po kliknięciu na nazwę questu w QuestTracker   
   hooksecurefunc(QUEST_TRACKER_MODULE, "OnBlockHeaderClick", QTR_QuestLogOpen);
   
   -- funkcja wywoływana po kliknięciu na nazwę questu w QuestMapFrame
   hooksecurefunc("QuestMapFrame_ShowQuestDetails", QTR_QuestLogOpen);
   
   if (QuestGuru ~= nil ) then
      -- przycisk z nr ID questu w QuestGuru
      QTR_ToggleButton3 = CreateFrame("Button",nil, QuestGuru, "UIPanelButtonTemplate");
      QTR_ToggleButton3:SetWidth(150);
      QTR_ToggleButton3:SetHeight(20);
      QTR_ToggleButton3:SetText("Quest ID=?");
      QTR_ToggleButton3:Show();
      QTR_ToggleButton3:ClearAllPoints();
      QTR_ToggleButton3:SetPoint("TOPLEFT", QuestGuru, "TOPLEFT", 350, -33);
      QTR_ToggleButton3:SetScript("OnClick", QTR_ON_OFF);
      -- otworzono QuestLog w QuestGuru
      QuestGuru:HookScript("OnShow",function() QTR_QuestLogOpen() end);
      -- kliknięto na nazwę questu w QuestLogu
      QuestGuru:HookScript("OnUpdate", function() QTR_QuestLogOpen() end);
   end
   
end



function QTR_ON_OFF()
   if (curr_trans=="1") then
      curr_trans="0";
      QTR_Translate_Off(1);
   else   
      curr_trans="1";
      QTR_Translate_On(1);
   end
end



-- Zmienne programowe zapisane na stałe na komputerze
function QuestTranslator_CheckVars()
  if (not QTR_PS) then
     QTR_PS = {};
  end
  if (not QTR_PC) then
     QTR_PC = {};
  end
  if (not QTR_SAVED) then
     QTR_SAVED = {};
  end
  -- inicjalizacja: tłumaczenia włączone
  if (not QTR_PS["active"]) then
     QTR_PS["active"] = "1";
  end
  -- inicjalizacja: tłumaczenie tytułu questu włączone
  if (not QTR_PS["transtitle"] ) then
     QTR_PS["transtitle"] = "0";   
  end
  -- zmienna specjalna dostępności funkcji GetQuestID 
  if ( QTR_PS["isGetQuestID"] ) then
     isGetQuestID=QTR_PS["isGetQuestID"];
  end;
  -- okresowe wyświetlanie reklam o dodatku 
  if (not QTR_PS["reklama"] ) then
     QTR_PS["reklama"] = "0";
     QTR_PS["period"] = 20;
     QTR_PS["text1"] = "0";
     QTR_PS["text2"] = "1";
  end;
end



-- Sprawdza dostępność funkcji specjalnej Wow'a: GetQuestID()
function DetectEmuServer()
  QTR_PS["isGetQuestID"]="0";
  isGetQuestID="0";
  -- funkcja GetQuestID() występuje tylko na serwerach Blizzarda
  if ( GetQuestID() ) then
     QTR_PS["isGetQuestID"]="1";
     isGetQuestID="1";
  end
end



-- Obsługa komend slash
function QTR_SlashCommand(msg)
   if (msg=="on" or msg=="ON") then
      if (QTR_PS["active"]=="1") then
         print ("QTR - tłumaczenie są włączone.");
      else
         print ("|cffffff00QTR - włączam tłumaczenie.");
         QTR_PS["active"] = "1";
         QTR_ToggleButton0:Enable();
         QTR_ToggleButton1:Enable();
         QTR_ToggleButton2:Enable();
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:Enable();
         end
         QTR_Translate_On(1);
      end
   elseif (msg=="off" or msg=="OFF") then
      if (QTR_PS["active"]=="0") then
         print ("QTR - tłumaczenia są wyłączone.");
      else
         print ("|cffffff00QTR - wyłączam tłumaczenia.");
         QTR_PS["active"] = "0";
         QTR_ToggleButton0:Disable();
         QTR_ToggleButton1:Disable();
         QTR_ToggleButton2:Disable();
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:Disable();
         end
         QTR_Translate_Off(1);
      end
   elseif (msg=="title on" or msg=="TITLE ON" or msg=="title 1") then
      if (QTR_PS["transtilte"]=="1") then
         print ("QTR - tłumaczenie tytułów jest włączone.");
      else
         print ("|cffffff00QTR - włączam tłumaczenie tytułów.");
         QTR_PS["transtitle"] = "1";
         QuestInfoTitleHeader:SetFont(QTR_Font1, 18);
      end
   elseif (msg=="title off" or msg=="TITLE OFF" or msg=="title 0") then
      if (QTR_PS["transtilte"]=="0") then
         print ("QTR - tłumaczenie tytułów jest wyłączone.");
      else
         print ("|cffffff00QTR - wyłączam tłumaczenie tytułów.");
         QTR_PS["transtitle"] = "0";
         QuestInfoTitleHeader:SetFont(Original_Font1, 18);
      end
   elseif (msg=="title" or msg=="TITLE") then
      if (QTR_PS["transtilte"]=="1") then
         print ("QTR - tłumaczenie tytułów jest włączone.");
      else
         print ("QTR - tłumaczenie tytułów jest wyłączone.");
      end
   elseif (msg=="") then
      InterfaceOptionsFrame_Show();
      InterfaceOptionsFrame_OpenToCategory(QuestTranslatorOptions);
   else
      print ("QTR - menu szybkich komend addonu:");
      print ("      /qtr on  - włącza tłumaczenia");
      print ("      /qtr off - wyłącza tłumaczenia");
      print ("      /qtr title on  - włącza tłumaczenie tytułu");
      print ("      /qtr title off - wyłącza tłumaczenie tytułu");
   end
   if (QTR_PS["reklama"]=="1") then
      QTR_SendReklama();
   end
end



function QuestTranslator_SetCheckButtonState()
  QuestTranslatorCheckButton0:SetChecked(QTR_PS["active"]=="1");
  QuestTranslatorCheckButton3:SetChecked(QTR_PS["transtitle"]=="1");
  QuestTranslatorCheckButton5:SetChecked(QTR_PS["reklama"]=="1");
  QuestTranslatorCheckText1:SetChecked(QTR_PS["text1"]=="1");
  QuestTranslatorCheckText2:SetChecked(QTR_PS["text2"]=="1");
end



function QuestTranslator_BlizzardOptions()
  -- Create main frame for information text
  local QuestTranslatorOptions = CreateFrame("FRAME", "QuestTranslatorOptions");
--  QuestTranslatorOptions:SetScript("OnShow", function(self) QuestTranslator_SetCheckButtonState() end);
  QuestTranslatorOptions.name = "QuestTranslator";
  QuestTranslatorOptions.refresh = function (self) QuestTranslator_SetCheckButtonState() end;
  InterfaceOptions_AddCategory(QuestTranslatorOptions);

  local QuestTranslatorOptionsHeader = QuestTranslatorOptions:CreateFontString(nil, "ARTWORK");
  QuestTranslatorOptionsHeader:SetFontObject(GameFontNormalLarge);
  QuestTranslatorOptionsHeader:SetJustifyH("LEFT"); 
  QuestTranslatorOptionsHeader:SetJustifyV("TOP");
  QuestTranslatorOptionsHeader:ClearAllPoints();
  QuestTranslatorOptionsHeader:SetPoint("TOPLEFT", 16, -16);
  QuestTranslatorOptionsHeader:SetText("QuestTranslator, ver. "..QTR_version.." "..QTR_lang.." ("..QTR_base..") by Platine © 2010-2016");

  local QuestTranslatorCheckButton0 = CreateFrame("CheckButton", "QuestTranslatorCheckButton0", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckButton0:SetPoint("TOPLEFT", QuestTranslatorOptionsHeader, "BOTTOMLEFT", 0, -20);
  QuestTranslatorCheckButton0:SetScript("OnClick", function(self) if (QTR_PS["active"]=="1") then QTR_PS["active"]="0" else QTR_PS["active"]="1" end; end);
  QuestTranslatorCheckButton0Text:SetFont(QTR_Font2, 13);
  QuestTranslatorCheckButton0Text:SetText(QTR_Interface.active);

  local QuestTranslatorOptionsMode1 = QuestTranslatorOptions:CreateFontString(nil, "ARTWORK");
  QuestTranslatorOptionsMode1:SetFontObject(GameFontWhite);
  QuestTranslatorOptionsMode1:SetJustifyH("LEFT");
  QuestTranslatorOptionsMode1:SetJustifyV("TOP");
  QuestTranslatorOptionsMode1:ClearAllPoints();
  QuestTranslatorOptionsMode1:SetPoint("TOPLEFT", QuestTranslatorCheckButton0, "BOTTOMLEFT", 30, -20);
  QuestTranslatorOptionsMode1:SetFont(QTR_Font2, 13);
  QuestTranslatorOptionsMode1:SetText(QTR_Interface.options1);
  
  local QuestTranslatorCheckButton3 = CreateFrame("CheckButton", "QuestTranslatorCheckButton3", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckButton3:SetPoint("TOPLEFT", QuestTranslatorOptionsMode1, "BOTTOMLEFT", 0, -5);
  QuestTranslatorCheckButton3:SetScript("OnClick", function(self) if (QTR_PS["transtitle"]=="0") then QTR_PS["transtitle"]="1" else QTR_PS["transtitle"]="0" end; end);
  QuestTranslatorCheckButton3Text:SetFont(QTR_Font2, 13);
  QuestTranslatorCheckButton3Text:SetText(QTR_Interface.transtitle);

  local QuestTranslatorCheckButton5 = CreateFrame("CheckButton", "QuestTranslatorCheckButton5", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckButton5:SetPoint("TOPLEFT", QuestTranslatorCheckButton3, "BOTTOMLEFT", 0, -50);
  QuestTranslatorCheckButton5:SetScript("OnClick", function(self) if (QTR_PS["reklama"]=="0") then QTR_PS["reklama"]="1" else QTR_PS["reklama"]="0" end; end);
  QuestTranslatorCheckButton5Text:SetFont(QTR_Font2, 13);
  QuestTranslatorCheckButton5Text:SetText(QTR_Reklama.ON);

  local QuestTranslatorPeriodText = QuestTranslatorOptions:CreateFontString(nil, "ARTWORK");
  QuestTranslatorPeriodText:SetFontObject(GameFontWhite);
  QuestTranslatorPeriodText:SetJustifyH("LEFT");
  QuestTranslatorPeriodText:SetJustifyV("TOP");
  QuestTranslatorPeriodText:ClearAllPoints();
  QuestTranslatorPeriodText:SetPoint("TOPLEFT", QuestTranslatorCheckButton5, "BOTTOMLEFT", 30, -10);
  QuestTranslatorPeriodText:SetFont(QTR_Font2, 13);
  QuestTranslatorPeriodText:SetText(QTR_Reklama.PERIOD);
  
  local QTR_slider = CreateFrame("Slider","MyAddonSlider",QuestTranslatorOptions,'OptionsSliderTemplate');
  QTR_slider:ClearAllPoints();
  QTR_slider:SetPoint("TOPLEFT",QuestTranslatorPeriodText, "BOTTOMLEFT", 80, -30);
  getglobal(QTR_slider:GetName() .. 'Low'):SetText('15 min.');
  getglobal(QTR_slider:GetName() .. 'High'):SetText('90 min.');
  getglobal(QTR_slider:GetName() .. 'Text'):SetText('20 min.');
  QTR_slider:SetMinMaxValues(15, 90);
  QTR_slider:SetValue(QTR_PS["period"]);
  getglobal(QTR_slider:GetName() .. 'Text'):SetText(QTR_PS["period"] .. " min.");
  QTR_slider:SetValueStep(5);
  QTR_slider:SetScript("OnValueChanged", function(self)
      QTR_PS["period"] = round(QTR_slider:GetValue(),0);
      getglobal(QTR_slider:GetName() .. 'Text'):SetText(QTR_PS["period"] .. " min.");
      end);

  local QuestTranslatorChoiceText = QuestTranslatorOptions:CreateFontString(nil, "ARTWORK");
  QuestTranslatorChoiceText:SetFontObject(GameFontWhite);
  QuestTranslatorChoiceText:SetJustifyH("LEFT");
  QuestTranslatorChoiceText:SetJustifyV("TOP");
  QuestTranslatorChoiceText:ClearAllPoints();
  QuestTranslatorChoiceText:SetPoint("TOPLEFT", QuestTranslatorPeriodText, "BOTTOMLEFT", 0, -80);
  QuestTranslatorChoiceText:SetFont(QTR_Font2, 13);
  QuestTranslatorChoiceText:SetText(QTR_Reklama.CHOICE);
  
  local QuestTranslatorCheckText1 = CreateFrame("CheckButton", "QuestTranslatorCheckText1", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckText1:SetPoint("TOPLEFT", QuestTranslatorChoiceText, "BOTTOMLEFT", -50, -20);
  QuestTranslatorCheckText1:SetScript("OnClick", function(self) if (QTR_PS["text1"]=="0") then QTR_PS["text1"]="1" else QTR_PS["text1"]="0" end; end);
  QuestTranslatorCheckText1Text:SetFont(QTR_Font2, 13);
  QuestTranslatorCheckText1Text:SetText(QTR_Reklama.TEXT1);

  local QuestTranslatorCheckText2 = CreateFrame("CheckButton", "QuestTranslatorCheckText2", QuestTranslatorOptions, "OptionsCheckButtonTemplate");
  QuestTranslatorCheckText2:SetPoint("TOPLEFT", QuestTranslatorCheckText1, "BOTTOMLEFT", 0, -10);
  QuestTranslatorCheckText2:SetScript("OnClick", function(self) if (QTR_PS["text2"]=="0") then QTR_PS["text2"]="1" else QTR_PS["text2"]="0" end; end);
  QuestTranslatorCheckText2Text:SetFont(QTR_Font2, 13);
  QuestTranslatorCheckText2Text:SetText(QTR_Reklama.TEXT2);

end



-- Określa aktualny numer ID questu z różnych metod
function QTR_GetQuestID()
   quest_ID = QuestMapFrame.DetailsFrame.questID;
   
   if (quest_ID==nil) then
      quest_ID = QuestLogPopupDetailFrame.questID;
   end
   
   if (quest_ID==nil) then
      if ((QuestGuru ~= nil) and (QuestGuru:IsVisible())) then
         local questTitle, level, questTag, suggestedGroup, isHeader, isComplete, isDaily, questID = GetQuestLogTitle(GetQuestLogSelection());
         if (not isHeader) then
            quest_ID = questID;
         end
      end
   end
   
   if (quest_ID==nil) then
      if ( isGetQuestID=="1" ) then
         quest_ID = GetQuestID();
      end
   end         

   if (quest_ID==nil) then
      quest_ID=0;
   end   
   
   return (quest_ID);
end



-- Wywoływane przy przechwytywanych zdarzeniach
function QTR_OnEvent(self, event, name, ...)
   if (event=="ADDON_LOADED" and name=="QuestTranslator") then
      SlashCmdList["QUESTTRANSLATOR"] = function(msg) QTR_SlashCommand(msg); end
      SLASH_QUESTTRANSLATOR1 = "/questtranslator";
      SLASH_QUESTTRANSLATOR2 = "/qtr";
      QuestTranslator_CheckVars();
      -- twórz interface Options w Blizzard-Interface-Addons
      QuestTranslator_BlizzardOptions();
      print ("|cffffff00QuestTranslator ver. "..QTR_version.." "..QTR_lang.." - "..QuestTranslator_Messages.loaded);
      QTR:UnregisterEvent("ADDON_LOADED");
      QTR.ADDON_LOADED = nil;
      if (not isGetQuestID) then
         DetectEmuServer();
      end
      if (QTR_PS["active"]=="1") then
         QTR_Translate_On();
         QTR_ToggleButton0:Enable();
         QTR_ToggleButton1:Enable();
         QTR_ToggleButton2:Enable();
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:Enable();
         end
      else
         QTR_ToggleButton0:Disable();
         QTR_ToggleButton1:Disable();
         QTR_ToggleButton2:Disable();
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:Disable();
         end
      end
   elseif (event=="QUEST_DETAIL" or event=="QUEST_PROGRESS" or event=="QUEST_COMPLETE") then
      if ( QuestFrame:IsVisible() ) then
         QTR_quest_EN.id = 0;
         QTR_quest_LG.id = 0;
         q_ID = QTR_GetQuestID();
         str_ID=tostring(q_ID);
         if ( QTR_PS["active"]=="1" ) then	-- tłumaczenia włączone
            curr_trans = "1";
            if ( QuestTranslator_QuestData[str_ID] ) then
               -- wyświetlaj tylko, gdy istnieje tłumaczenie
               QTR_quest_EN.id = q_ID;
               QTR_quest_LG.id = q_ID;
               QTR_quest_EN.title = GetTitleText();
               QTR_quest_LG.title = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Title"]);
               QTR_quest_EN.details = GetQuestText();
               QTR_quest_LG.details = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Description"]);
               QTR_quest_EN.objectives = GetObjectiveText();
               QTR_quest_LG.objectives = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Objectives"]);
               QTR_quest_EN.progress = GetProgressText();
               QTR_quest_LG.progress = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Progress"]);
               QTR_quest_EN.completion = GetRewardText();
               QTR_quest_LG.completion = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Completion"]);
               if (event=="QUEST_DETAIL") then
                  QTR_quest_EN.itemchoose = QuestTranslator_MessOrig.itemchoose1;
                  QTR_quest_LG.itemchoose = QuestTranslator_Messages.itemchoose1;
                  QTR_quest_EN.itemreceive = QuestTranslator_MessOrig.itemreceiv1;
                  QTR_quest_LG.itemreceive = QuestTranslator_Messages.itemreceiv1;
               end
               if (event=="QUEST_COMPLETE") then
                  QTR_quest_EN.itemchoose = QuestTranslator_MessOrig.itemchoose2;
                  QTR_quest_LG.itemchoose = QuestTranslator_Messages.itemchoose2;
                  QTR_quest_EN.itemreceive = QuestTranslator_MessOrig.itemreceiv2;
                  QTR_quest_LG.itemreceive = QuestTranslator_Messages.itemreceiv2;
               end
               QTR_Translate_On(1);
            else	-- nie ma przetłumaczonego takiego questu
               QTR_ToggleButton0:SetText("Quest ID="..str_ID);
               QTR_Translate_On(0);
               if (event=="QUEST_DETAIL") then
                  QTR_SAVED[str_ID.." TITLE"]=GetTitleText();            -- save original title to future translation
                  QTR_SAVED[str_ID.." DESCRIPTION"]=GetQuestText();      -- save original text to future translation
                  QTR_SAVED[str_ID.." OBJECTIVE"]=GetObjectiveText();    -- save original text to future translation
               end
               if (event=="QUEST_PROGRESS") then
                  QTR_SAVED[str_ID.." PROGRESS"]=GetProgressText();      -- save original text to future translation
               end
               if (event=="QUEST_COMPLETE") then
                  QTR_SAVED[str_ID.." COMPLETE"]=GetRewardText();        -- save original text to future translation
               end
            end -- jest przetłumaczony quest w bazie
         else	-- tłumaczenia wyłączone
            if ( QuestTranslator_QuestData[str_ID] ) then	-- ale jest tłumaczenie w bazie
               QTR_ToggleButton0:SetText("Quest ID="..str_ID.." (EN)");
            else
               QTR_ToggleButton0:SetText("Quest ID="..str_ID);
            end
         end	-- tłumaczenia są włączone
      end	-- QuestFrame is Visible
   end
   if (QTR_PS["reklama"]=="1") then
      QTR_SendReklama();
   end
end



-- Otworzono okienko QuestLogPopupDetailFrame lub QuestMapDetailsScrollFrame lub QuestGuru
function QTR_QuestLogOpen()
   QTR_quest_EN.id = 0;
   QTR_quest_LG.id = 0;
   q_ID = QTR_GetQuestID();
   str_ID = tostring(q_ID);
   if ( QTR_PS["active"]=="1" ) then	-- tłumaczenia włączone
      curr_trans = "1";
      if ( QuestTranslator_QuestData[str_ID] ) then
         -- wyświetlaj tylko, gdy istnieje tłumaczenie
         QTR_quest_EN.id = q_ID;
         QTR_quest_LG.id = q_ID;
         QTR_quest_EN.title = QuestInfoTitleHeader:GetText();
         QTR_quest_LG.title = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Title"]);
         QTR_quest_EN.details = QuestInfoDescriptionText:GetText();
         QTR_quest_LG.details = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Description"]);
         QTR_quest_EN.objectives = QuestInfoObjectivesText:GetText();
         QTR_quest_LG.objectives = QTR_ExpandUnitInfo(QuestTranslator_QuestData[str_ID]["Objectives"]);
         QTR_quest_EN.itemchoose = QuestTranslator_MessOrig.itemchoose1;
         QTR_quest_LG.itemchoose = QuestTranslator_Messages.itemchoose1;
         QTR_quest_EN.itemreceive = QuestTranslator_MessOrig.itemreceiv1;
         QTR_quest_LG.itemreceive = QuestTranslator_Messages.itemreceiv1;
--         if ( not QTR_wait(0.5,QTR_Translate_On(1)) ) then
            QTR_Translate_On(1);
--         end   
      else	-- nie ma przetłumaczonego takiego questu
         QTR_ToggleButton1:SetText("Quest ID="..str_ID);
         QTR_ToggleButton2:SetText("Quest ID="..str_ID);
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:SetText("Quest ID="..str_ID);
         end
         QTR_Translate_On(0);
      end -- jest przetłumaczony quest w bazie
   else	-- tłumaczenia wyłączone
      if ( QuestTranslator_QuestData[str_ID] ) then	-- ale jest tłumaczenie w bazie
         QTR_ToggleButton1:SetText("Quest ID="..str_ID.." (EN)");
         QTR_ToggleButton2:SetText("Quest ID="..str_ID.." (EN)");
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:SetText("Quest ID="..str_ID.." (EN)");
         end
      else
         QTR_ToggleButton1:SetText("Quest ID="..str_ID);
         QTR_ToggleButton2:SetText("Quest ID="..str_ID);
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:SetText("Quest ID="..str_ID);
         end
      end
   end	-- tłumaczenia są włączone
   if (QTR_PS["reklama"]=="1") then
      QTR_SendReklama();
   end
end



-- podmieniaj specjane znaki w tekście
function QTR_ExpandUnitInfo(msg)
   msg = string.gsub(msg, "NEW_LINE", "\n");
   msg = string.gsub(msg, "YOUR_NAME", QTR_name);
   msg = string.gsub(msg, "YOUR_CLASS", QTR_class);
   msg = string.gsub(msg, "YOUR_RACE", QTR_race);
   return msg;
end



-- wyświetla tłumaczenie
function QTR_Translate_On(typ)
   if (QTR_PS["transtitle"]=="1") then
      QuestInfoTitleHeader:SetFont(QTR_Font1, 18);
      QuestProgressTitleText:SetFont(QTR_Font1, 18);
   end
   QuestInfoObjectivesHeader:SetText(QuestTranslator_Messages.objectives);
   QuestInfoObjectivesHeader:SetFont(QTR_Font1, 18);
   QuestInfoRewardsFrame.Header:SetText(QuestTranslator_Messages.rewards);
   QuestInfoRewardsFrame.Header:SetFont(QTR_Font1, 18);
   QuestInfoDescriptionHeader:SetText(QuestTranslator_Messages.details);
   QuestInfoDescriptionHeader:SetFont(QTR_Font1, 18);
   QuestProgressRequiredItemsText:SetText(QuestTranslator_Messages.reqitems);
   QuestProgressRequiredItemsText:SetFont(QTR_Font1, 18);
   QuestInfoDescriptionText:SetFont(QTR_Font2, 13);
   QuestInfoObjectivesText:SetFont(QTR_Font2, 13);
   QuestProgressText:SetFont(QTR_Font2, 13);
   QuestInfoRewardText:SetFont(QTR_Font2, 13);
   QuestInfoRewardsFrame.ItemChooseText:SetFont(QTR_Font2, 13);
   QuestInfoRewardsFrame.ItemReceiveText:SetFont(QTR_Font2, 13);
   MapQuestInfoRewardsFrame.ItemReceiveText:SetFont(QTR_Font2, 13);
   QuestInfoSpellObjectiveLearnLabel:SetText(QuestTranslator_Messages.learnspell);
   QuestInfoSpellObjectiveLearnLabel:SetFont(QTR_Font2, 13);
   QuestInfoXPFrame.ReceiveText:SetText(QuestTranslator_Messages.experience);
   QuestInfoXPFrame.ReceiveText:SetFont(QTR_Font2, 13);
   if (typ==1) then			-- pełne przełączenie
      QuestInfoRewardsFrame.ItemChooseText:SetText(QuestTranslator_Messages.itemchoose1);
      QuestInfoRewardsFrame.ItemReceiveText:SetText(QuestTranslator_Messages.itemreceiv1);
      MapQuestInfoRewardsFrame.ItemReceiveText:SetText(QuestTranslator_Messages.itemreceiv1);
      numer_ID = QTR_GetQuestID();
      if (numer_ID>0 and numer_ID==QTR_quest_LG.id) then	-- przywróć przetłumaczoną wersję napisów
         QTR_ToggleButton0:SetText("Quest ID="..QTR_quest_LG.id.." ("..QTR_lang..")");
         QTR_ToggleButton1:SetText("Quest ID="..QTR_quest_LG.id.." ("..QTR_lang..")");
         QTR_ToggleButton2:SetText("Quest ID="..QTR_quest_LG.id.." ("..QTR_lang..")");
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:SetText("Quest ID="..QTR_quest_LG.id.." ("..QTR_lang..")");
         end
         if (QTR_PS["transtitle"]=="1") then
            QuestInfoTitleHeader:SetText(QTR_quest_LG.title);
         end
         QuestProgressTitleText:SetText(QTR_quest_LG.title);
         QuestInfoDescriptionText:SetText(QTR_quest_LG.details);
         QuestInfoObjectivesText:SetText(QTR_quest_LG.objectives);
         QuestProgressText:SetText(QTR_quest_LG.progress);
         QuestInfoRewardText:SetText(QTR_quest_LG.completion);
         QuestInfoRewardsFrame.ItemChooseText:SetText(QTR_quest_LG.itemchoose);
         QuestInfoRewardsFrame.ItemReceiveText:SetText(QTR_quest_LG.itemreceive);
      end
   else
      if (curr_trans == "1") then
         QuestInfoRewardsFrame.ItemChooseText:SetText(QuestTranslator_Messages.itemchoose1);
         QuestInfoRewardsFrame.ItemReceiveText:SetText(QuestTranslator_Messages.itemreceiv1);
      end
   end
end



-- wyświetla oryginalny tekst
function QTR_Translate_Off(typ)
   QuestInfoTitleHeader:SetFont(Original_Font1, 18);
   QuestProgressTitleText:SetFont(Original_Font1, 18);
   QuestInfoObjectivesHeader:SetText(QuestTranslator_MessOrig.objectives);
   QuestInfoObjectivesHeader:SetFont(Original_Font1, 18);
   QuestInfoRewardsFrame.Header:SetText(QuestTranslator_MessOrig.rewards);
   QuestInfoRewardsFrame.Header:SetFont(Original_Font1, 18);
   QuestInfoDescriptionHeader:SetText(QuestTranslator_MessOrig.details);
   QuestInfoDescriptionHeader:SetFont(Original_Font1, 18);
   QuestProgressRequiredItemsText:SetText(QuestTranslator_MessOrig.reqitems);
   QuestProgressRequiredItemsText:SetFont(Original_Font1, 18);
   QuestInfoDescriptionText:SetFont(Original_Font2, 13);
   QuestInfoObjectivesText:SetFont(Original_Font2, 13);
   QuestProgressText:SetFont(Original_Font2, 13);
   QuestInfoRewardText:SetFont(Original_Font2, 13);
   QuestInfoRewardsFrame.ItemChooseText:SetFont(Original_Font2, 13);
   QuestInfoRewardsFrame.ItemReceiveText:SetFont(Original_Font2, 13);
   MapQuestInfoRewardsFrame.ItemReceiveText:SetFont(Original_Font2, 13);
   QuestInfoSpellObjectiveLearnLabel:SetText(QuestTranslator_MessOrig.learnspell);
   QuestInfoSpellObjectiveLearnLabel:SetFont(Original_Font2, 13);
   QuestInfoXPFrame.ReceiveText:SetText(QuestTranslator_MessOrig.experience);
   QuestInfoXPFrame.ReceiveText:SetFont(Original_Font2, 13);
   if (typ==1) then			-- pełne przełączenie
      QuestInfoRewardsFrame.ItemChooseText:SetText(QuestTranslator_MessOrig.itemchoose1);
      QuestInfoRewardsFrame.ItemReceiveText:SetText(QuestTranslator_MessOrig.itemreceiv1);
      MapQuestInfoRewardsFrame.ItemReceiveText:SetText(QuestTranslator_MessOrig.itemreceiv1);
      numer_ID = QTR_GetQuestID();
      if (numer_ID>0 and numer_ID==QTR_quest_EN.id) then	-- przywróć oryginalną wersję napisów
         QTR_ToggleButton0:SetText("Quest ID="..QTR_quest_EN.id.." (EN)");
         QTR_ToggleButton1:SetText("Quest ID="..QTR_quest_EN.id.." (EN)");
         QTR_ToggleButton2:SetText("Quest ID="..QTR_quest_EN.id.." (EN)");
         if (QuestGuru ~= nil ) then
            QTR_ToggleButton3:SetText("Quest ID="..QTR_quest_EN.id.." (EN)");
         end
         QuestInfoTitleHeader:SetText(QTR_quest_EN.title);
         QuestProgressTitleText:SetText(QTR_quest_EN.title);
         QuestInfoDescriptionText:SetText(QTR_quest_EN.details);
         QuestInfoObjectivesText:SetText(QTR_quest_EN.objectives);
         QuestProgressText:SetText(QTR_quest_EN.progress);
         QuestInfoRewardText:SetText(QTR_quest_EN.completion);
         QuestInfoRewardsFrame.ItemChooseText:SetText(QTR_quest_EN.itemchoose);
         QuestInfoRewardsFrame.ItemReceiveText:SetText(QTR_quest_EN.itemreceive);
      end
   end
end


function QTR_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(QTR_waitFrame == nil) then
    QTR_waitFrame = CreateFrame("Frame","QTR_WaitFrame", UIParent);
    QTR_waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #QTR_waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(QTR_waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(QTR_waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(QTR_waitTable,{delay,func,{...}});
  return true;
end


function QTR_SendReklama()
  local now = GetTime();
  if (last_time + QTR_PS["period"]*60 < now) then                  -- OK, czas wypisać reklamę
     if ((QTR_PS["text1"]=="1") and (QTR_PS["text2"]=="1")) then   -- oba teksty naprzemiennie
        if (last_text==2) then
           SendChatMessage(QTR_Reklama.TEXT1,"CHANNEL",nil,1);
           last_text = 1;
        else
           SendChatMessage(QTR_Reklama.TEXT2,"CHANNEL",nil,1);
           last_text = 2;
        end
     elseif (QTR_PS["text1"]=="1") then
        SendChatMessage(QTR_Reklama.TEXT1,"CHANNEL",nil,1);
        last_text = 1;
     elseif (QTR_PS["text2"]=="1") then
        SendChatMessage(QTR_Reklama.TEXT2,"CHANNEL",nil,1);
        last_text = 2;
     end
     last_time = now;
  end   
end